/*
 * tunnels.c		<MGater libs>
 */

#include <stdlib.h>
#include <errno.h>
#include <string.h>
//#define __need_timeval
//#undef _BITS_TIME_H
//#undef _STRUCT_TIMEVAL
//#include <bits/time.h>
#include <sys/time.h>
#include <time.h>
#include "libmnet.h"

//DESCRIPTOR_DATA_TUNNEL		* tunnel_list;
varr	tunnel_list = { sizeof (DESCRIPTOR_DATA_TUNNEL), 2 };

/*
 *	return id of tunnel
 *	(-1) - error
 */
int new_tunnel(void)
{
	DESCRIPTOR_DATA_TUNNEL	* dnew;
	DESCRIPTOR_DATA_TUNNEL	* itun;
	int	i;
	int	id = 0;

	
	for (i = 0; i < tunnel_list.nused; i++) {
		itun = VARR_GET(&tunnel_list, i);
		if (id == itun->idtun)
			id++;
	}

	dnew = varr_enew(&tunnel_list);
	/*
	if ((dnew = calloc(1, sizeof(*dnew))) == NULL)
	{
		log_printf("new_tunnel: nomem");
		return NULL;
	}
	*/
	dnew->idtun			= id;
	dnew->listening_sockets.nsize	= sizeof(insockets_t);
	dnew->listening_sockets.nstep	= 1;
	dnew->from_connect		= NULL;
	dnew->clients			= NULL;
	

	varr_qsort(&tunnel_list, cmpint);	// !!!
//	dnew->next			= tunnel_list;
//	tunnel_list			= dnew;

	return id;
}

/*
 * Init tunnel for clients(aka end users)
 *	localports - associated ports for this tunnel. Will bind in this func,
 *			varr of int's.
 */
int	init_local_clients_tunnel(varr *localports, const char * msg)
{
	DESCRIPTOR_DATA_TUNNEL	* d_tunnel;
	int			i, idtun;
	int			socket;
	int			* port;
	insockets_t 		* listen_data;

	if (localports->nused <= 0)
	{
		return -1;
	}

	if ((idtun = new_tunnel()) == -1)
		return -1;
	d_tunnel = VARR_GET(&tunnel_list, idtun);

	d_tunnel->from_connect = NULL;		// local tunnel

	for (i = 0; i < localports->nused; i++)
	{
		port = ((int *) VARR_GET(localports, i));
		
		if ((socket = init_socket(*port, TRUE, TRUE)) > 0)
		{
			listen_data = varr_enew(&(d_tunnel->listening_sockets));

			listen_data->port		= *port;
			listen_data->socket		= socket;
			listen_data->trusted_addr.nsize	= sizeof(struct in_addr);
			listen_data->trusted_addr.nstep	= 1;
			listen_data->idtun		= idtun;

			log_printf("%s: bind %d port success (tun: %d)",
					msg ? msg : str_empty, *port,
					idtun);
		}
	}

	return idtun;
}

bool begin_work_with_tunnel(int idtun)
{
	DESCRIPTOR_DATA_TUNNEL * d_tunnel;
	int i;
	insockets_t *lists;
	bool ret = TRUE;

	if ((d_tunnel = varr_get(&tunnel_list, idtun)) == NULL)
		return FALSE;
	
	for (i = 0; i < d_tunnel->listening_sockets.nused; i++)
	{
		lists = ((insockets_t *)
				VARR_GET((&(d_tunnel->listening_sockets)), i));
		if (!accept_socket(lists->socket, idtun))
			ret = FALSE;
	}
	log_printf("Begin work with tunnel '%d' started", idtun);
	return ret;
}

/*
int check_assoc_port(int port)
{
	DESCRIPTOR_DATA_TUNNEL *dm;
	int k, i;
	insockets_t *asport;

	//for (dm = tunnel_list; dm; dm = dm->next)
	for (k = 0; k < tunnel_list.nused; k++) {
	{
		dm = VARR_GET(&tunnel_list, k);
		for (i = 0; i < dm->listening_sockets.nused; i++)
		{
			asport = ((insockets_t *) VARR_GET((&(dm->listening_sockets)), i));
			if (asport->port == port)
				return dm->idtun;
		}
	}

	return -1;
}
*/

void shutdown_tunnel(int idtun)
{
}

extern FILE * rfin;		/* from resolver.c */
/*
 *	return FALSE if network broken
 *		example, interface at shutdown
 */
bool process_in_all_tunnels(void)
{
	fd_set in_set;
	fd_set out_set;
	fd_set exc_set;
	DESCRIPTOR_DATA_TUNNEL	*dt;
	insockets_t		*lsock;
	DESCRIPTOR_DATA_CLIENT	*client;
	int maxdesc = 0;
	int itun, ils;
	int fd;
	int fd_rfin = rfin ? fileno(rfin) : -1;	// for resolver
	static struct timeval null_time_loop = {0, 0};
	
	FD_ZERO(&in_set	);
	FD_ZERO(&out_set);
	FD_ZERO(&exc_set);

	/*
	 * Poll all active descriptors.
	 */
	for (itun = 0; itun < tunnel_list.nused; itun++)
	{
		dt = VARR_GET(&tunnel_list, itun);

		/* check new tunnels here !!!! */
		// ... 

		for (ils = 0; ils < dt->listening_sockets.nused; ils++)
		{
			lsock = ((insockets_t *)
				VARR_GET((&(dt->listening_sockets)), ils));
			FD_SET(lsock->socket, &in_set);
			if (maxdesc < lsock->socket)
				maxdesc = lsock->socket;
		}
		for (client = dt->clients; client; client = client->next)
		{
			if (client->connect)
			{
				fd = client->connect->socket;
				
				FD_SET(fd, &in_set);
				FD_SET(fd, &out_set);
				FD_SET(fd, &exc_set);
				maxdesc = UMAX(maxdesc, fd);
			} else
				log_printf("***BUG:: check_conn_alltun: client"
						" %d not connect",
						client->cid);
		}
	}

	if (fd_rfin >= 0)
	{
		/* Poll resolver */
		FD_SET(fd_rfin, &in_set);
		maxdesc = UMAX(maxdesc, fd_rfin);
	}
	
	if (select(maxdesc+1,
			&in_set, &out_set, &exc_set, &null_time_loop) < 0)
	{
		log_printf("check_conn_alltun: select: %s", strerror(errno));
		log_printf("check_conn_alltun: null_time: tv_sec=%d tv_usec=%d",
				null_time_loop.tv_sec, null_time_loop.tv_usec);
		exit(1);
	}

	if (fd_rfin >= 0 && FD_ISSET(fd_rfin, &in_set))
		resolv_check();

	/* Check new connections and kick out with any errors,
	 * 	example: simple disconnecting
	 */
	for (itun = 0; itun < tunnel_list.nused; itun++)
	{
		dt = VARR_GET(&tunnel_list, itun);

		/* check new connections */
		for (ils = 0; ils < dt->listening_sockets.nused; ils++)
		{
			lsock = ((insockets_t *)
				VARR_GET((&(dt->listening_sockets)), ils));
			if (FD_ISSET(lsock->socket, &in_set))
			{
				DESCRIPTOR_DATA_CLIENT * newclient;
				if ((newclient = init_descriptor_client(lsock))
								== NULL)
				{
					continue;
				}
				SET_BIT(newclient->flags, DDCF_NEWCONNECT);
			}
		}

		/* check broken connections or some errors */
		for (client = dt->clients; client; client = client->next)
		{
			if (client->connect)
			{
				fd = client->connect->socket;
				
				if (FD_ISSET(fd, &exc_set))
				{
					FD_CLR(fd, &in_set );
	                                FD_CLR(fd, &out_set);
					if (client->connect)
						client->connect->outtop = 0;
					close_descriptor_client(client, NULL);
				}
				/* check out stream */
				if (FD_ISSET(fd, &out_set))
				{
					SET_BIT(client->flags, DDCF_CAN_OUT);
				} else {
					REMOVE_BIT(client->flags, DDCF_CAN_OUT);
				}
			} else
				log_printf("***BUG:: check_conn_alltun: client"
						" %d not connect",
						client->cid);
		}
	}

	/*
	 *	Process input.
	 */
	for (itun = 0; itun < tunnel_list.nused; itun++)
	{
		dt = VARR_GET(&tunnel_list, itun);
		for (client = dt->clients; client; client = client->next)
		{
			if (!client->connect)
				continue;
			fd = client->connect->socket;

			//if (!FD_ISSET(fd, &in_set))
			//	continue;
			if ((FD_ISSET(fd, &in_set) &&
				read_from_descriptor_main(client->connect) < 0
			)
			|| !read_from_descriptor_client(client))
			{
				FD_CLR(fd, &out_set);
				REMOVE_BIT(client->flags, DDCF_CAN_OUT);
				if (client->connect)
					client->connect->outtop = 0;
				close_descriptor_client(client, NULL);
				continue;
			}
		}
	}
	
	return TRUE;
}

/*
 *	return FALSE if network broken
 *		example, interface at shutdown
 */
bool process_out_all_tunnels(void)
{
	int	itun;
	DESCRIPTOR_DATA_TUNNEL	*dt;
	DESCRIPTOR_DATA_CLIENT	*client;
	
	/* out tunnels here !!!! */
	//...
	/*
	 *	Process output.
	 */
	for (itun = 0; itun < tunnel_list.nused; itun++)
	{
		dt = VARR_GET(&tunnel_list, itun);
		for (client = dt->clients; client; client = client->next)
		{
			if (!client->connect
			|| !IS_SET(client->flags, DDCF_CAN_OUT))
				continue;

			if (!process_output_main(client->connect))
			{
				if (client->connect)
					client->connect->outtop = 0;
				close_descriptor_client(client, NULL);
				continue;
			}
		}
	}
	return TRUE;
}

void tunnel_add_to_trusted_addr(int idtun, struct in_addr *in_addr)
{
	int i;
	insockets_t *lsock;
	DESCRIPTOR_DATA_TUNNEL  * dt = varr_get(&tunnel_list, idtun);
	
	if (!dt)
		return;
		
	for (i = 0; i < dt->listening_sockets.nused; i++)
	{
		lsock = ((insockets_t *)
			VARR_GET((&(dt->listening_sockets)), i));
		add_to_trusted_addr(lsock, in_addr);
	}
}

