/*
 * tunneling.c		<MGaterD>
 */

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "tunneling.h"

/*
 *	create connected tunnel
 *		target - target host.
 *		fromport_totarget - number of port which bind for
 *				create connect to target. If 0 or (-1) then
 *				port choose by system (OS).
 */
DESCRIPTOR_DATA_MAIN * connect_to_muddy(struct sockaddr_in *target,
		int fromport_totarget)
{
	DESCRIPTOR_DATA_MAIN	* t_connect;
	int ct_socket;	// connecting to muddy socket (tunnel socket)
	const char * msg = "connect_to_muddy";

	if ((ct_socket = init_socket(fromport_totarget,
				TRUE, TRUE)) < 0)
	{
		log_printf("%s: fail create socket", msg);
		return NULL;
	}

	/* connect to target host (create tunnel) */
	log_printf("%s: attempt connect to host: %s %d", msg,
		inet_ntoa(target->sin_addr), ntohs(target->sin_port));
		
	if (connect(ct_socket, (struct sockaddr*) target,
			sizeof(struct sockaddr_in)) < 0)
	{
		log_printf("%s: failed connect to %s %d (%d): %s", msg,
			inet_ntoa(target->sin_addr), ntohs(target->sin_port),
			target->sin_family, strerror(errno));
		close(ct_socket);
		return NULL;
	}

	t_connect = new_descriptor_main();

	t_connect->socket	= ct_socket;
	t_connect->outsize	= 8000;		/* to ... */
	t_connect->outbuf	= malloc(t_connect->outsize);
	t_connect->insize	= 8000;		/* in ... */
	t_connect->inbuf	= malloc(t_connect->insize);

	t_connect->hostname	= str_dup(inet_ntoa(target->sin_addr));
	memcmp(&t_connect->addr, target, sizeof(t_connect->addr));

	return t_connect;
}

